<template>
  <div id=''>
    <h1>
      Edit model: {{ schemaName }}
      <b-button  variant="success float-right">
          Save
      </b-button>
    </h1>

    <div v-for="item in fields">
      <schema-type-inputs :item='item' class="mt-2"/>
    </div>

    <hr/>

    <schema-new-field :schemaName='schemaName'/>

  </div>
</template>


<script>
import gql from 'graphql-tag';

import { defaultSchemaTypes, schemaTypes } from '@/data/parse';
import BuildObject from '@/utils/objectWrapper';
import SchemaTypeInputs from '@/components/SchemaTypeInputs.vue';
import SchemaNewField from '@/components/SchemaNewField.vue';


const FIELD = new BuildObject(
  { name: null, type: null, editable: true, new: false }
);

const SCHEMA_TYPES_QUERY = gql`query SchemaTypes($name: String) {
  schemaTypes(name: $name) {
    fields,
    classLevelPermissions
  }
}`;

export default {
  name: '',

  data() {
    return {

    };
  },

  components: {
    SchemaTypeInputs,
    SchemaNewField,
  },

  computed: {
    schemaName() {
      // Value set in Models.vue
      return this.$state.route.params.schemaName;
    },
    fields() {
      // Parse server returns an object of fields:
      // ex; { {objectId: { type: String }} }
      //
      // Return: [ {name: objectId, type: String, editable: true }]
      const fields = [];

      for (const [key, item] of Object.entries(this.schemaTypes.fields)) {
        FIELD.set('name', key);
        FIELD.set('type', item.type);

        if (defaultSchemaTypes.includes(key)) {
          FIELD.set('editable', false);
        }

        fields.push(FIELD.get(true));
      }

      return fields;
    },
  },

  apollo: {
    schemaTypes: {
      query: SCHEMA_TYPES_QUERY,
      variables() {
        return {
          name: this.$state.route.params.schemaName
        };
      },
    }
  },
};

</script>


<style lang='scss' scoped>

</style>
